<?php

include "control_web.inc";
include "gdwebdef.php";


#
# First part: 
#				Check whether every required parts of the webinterface
#				are installed.
#	

	
# mysql
$chk['mysqlaccess'] = @mysql_connect(MYSQL_HOST);
$chk['databaseaccess'] = @mysql_select_db(MYSQL_DB) && $chk['mysqlaccess'];
	
#########################################
	
# check if TEMP-Directory is readable and writeable	
$chk['tmprw'] = is_dir(PATH_ABSOLUTE_TEMP) && is_readable(PATH_ABSOLUTE_TEMP) && is_writable(PATH_ABSOLUTE_TEMP);
	
# check if Cover-Directory is readable and writeable	
$chk['coverrw'] = is_dir(PATH_ABSOLUTE_IMAGE) && is_readable(PATH_ABSOLUTE_IMAGE) && is_writable(PATH_ABSOLUTE_IMAGE);

# check if MP3/OGG-Directory is readable and writeable	
$chk['mp3rw'] = is_dir($PATH_ABSOLUTE_mp3) && is_readable($PATH_ABSOLUTE_mp3) && is_writable($PATH_ABSOLUTE_mp3);



#########################################
# Required Third Party Software

$chk['ripper'] = file_exists("$ripp_path$ripper");


$chk['encoder'] = file_exists("/usr/bin/$encoder");
if ($chk['encoder'] == false)
	{
	$chk['encoder'] = file_exists("/usr/local/bin/$encoder");
	}

	
if ($oggenc == "yes")
	$chk['oggenc'] = file_exists("/usr/bin/oggenc");

if ($oggenc == "yes")
	$chk['ogginfo'] = file_exists("/usr/bin/ogginfo");

if ($flacenc == "yes")
	$chk['flacenc'] = file_exists("/usr/bin/flac");


$chk['mp3info'] = file_exists("/usr/bin/mp3info");
if ($chk['mp3info'] == false)
	{
	$chk['mp3info'] = file_exists("/usr/local/bin/mp3info");
	}


	
if ($cdinfo == "yes")
{
$chk['cdinfo'] = file_exists("/usr/bin/cdinfo");
if ($chk['cdinfo'] == false)
	{
	$chk['cdinfo'] = file_exists("/usr/local/bin/cdinfo");
	}
$chk['cd-discid'] = file_exists("/usr/bin/cd-discid");
if ($chk['cd-discid'] == false)
	{
	$chk['cd-discid'] = file_exists("/usr/local/bin/cd-discid");
	}
}

if ($oggenc == "no" && $prefc == "ogg")
	{
	$chk['prefc'] = false;
	}




#########################################
	
	# check if there were errors
	$a=false; foreach($chk as $e=>$value) {
		if (!$value) { $a = true; break; }
	}
		
	# some errors where found
	if ($a) {

?>

<!DOCTYPE html
	PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>GiantDisc Web Interface: Init Error</title>
<link href="gdweb.css" rel="stylesheet" type="text/css">
<meta name="author" content="Jrgen Thns">
<meta name="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="expires" content="100">
<meta name="revisit-after" content="1">
<link rel="SHORTCUT ICON" href="img/gd16.ico">
</head>

<body>
		
<table cellspacing="20">
<tr>
<td valign="top">
<img src="img/mp3.jpg" height="75">
<img src="img/oggenc.gif" height="75">
<img src="img/flac.gif" height="75">
</td>
<td valign="top">
<h1>Init Error</h1>

<table cellspacing="10"> 
<tr><td colspan="3"><br><b>System</b></td></tr>


<tr>
<td valign="top">MP3-Directory read- & writable</td>
<td valign="top"><?php echo (($chk['mp3rw'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" alt=\"\">"); ?></td>
<td valign="top"><?php if (!$chk['mp3rw']): print "$output042" ?><?php endif; ?></td>													
</tr>																								

<tr>
<td valign="top">Cover-Directory read- & writable</td>
<td valign="top"><?php echo (($chk['coverrw'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" alt=\"\">"); ?></td>
<td valign="top"><?php if (!$chk['coverrw']): print "$output043" ?><?php endif; ?></td>													
</tr>																								

<tr>
<td valign="top">Temp-Directory read- & writable</td>
<td valign="top"><?php echo (($chk['tmprw'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" alt=\"\">"); ?></td>
<td valign="top"><?php if (!$chk['tmprw']): print "$output044" ?><?php endif; ?></td>													
</tr>			

							
<tr><td colspan="3"><br><b>MySQL</b></td></tr>
<tr>
<td valign="top">MySQL access</td>
<td valign="top"><?php echo (($chk['mysqlaccess'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" alt=\"\">"); ?></td>
<td valign="top"><?php if (!$chk['mysqlaccess']): print "$output040<br>$output041" ?><?php endif; ?></td>													
</tr>			

<tr>
<td valign="top">Database access</td>
<td valign="top"><?php echo (($chk['databaseaccess'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" alt=\"\">"); ?></td>
<td valign="top"><?php if (!$chk['databaseaccess']): print "$output038<br>$output039" ?><?php endif; ?></td>													
</tr>		

<tr><td colspan="3"><br><b>Required Third Party Software</b></td></tr>

<tr>
<td valign="top">ripper</td>
<td valign="top"><?php echo (($chk['ripper'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" alt=\"\">"); ?></td>
<td valign="top"><?php if (!$chk['ripper']): print "<b>$ripper</b>$output037" ?><?php endif; ?></td>													
</tr>		

<tr>
<td valign="top">encoder</td>
<td valign="top"><?php echo (($chk['encoder'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" alt=\"\">"); ?></td>
<td valign="top"><?php if (!$chk['encoder']): print "<b>$encoder</b>$output037" ?><?php endif; ?></td>													
</tr>		

<?php
if ($oggenc == "yes")
	{
	print "<tr><td valign=\"top\">oggenc</td><td valign=\"top\">";
	echo (($chk['oggenc'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" >");
	print "</td><td valign=\"top\">";
	if (!$chk['oggenc'])
		{
		print "<b>oggenc</b>";
		print "$output037";
		}
	print "</td></tr>";
	}
?>

<?php
if ($flacenc == "yes")
	{
	print "<tr><td valign=\"top\">flac</td><td valign=\"top\">";
	echo (($chk['flacenc'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" >");
	print "</td><td valign=\"top\">";
	if (!$chk['flacenc'])
		{
		print "<b>flac</b>";
		print "$output037";
		}
	print "</td></tr>";
	}
?>

<?php
if ($oggenc == "yes")
	{
	print "<tr><td valign=\"top\">ogginfo</td><td valign=\"top\">";
	echo (($chk['ogginfo'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" >");
	print "</td><td valign=\"top\">";
	if (!$chk['ogginfo'])
		{
		print "<b>ogginfo</b>";
		print "$output037";
		}
	print "</td></tr>";
	}
?>

<tr>
<td valign="top">mp3info</td>
<td valign="top"><?php echo (($chk['mp3info'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" alt=\"\">"); ?></td>
<td valign="top"><?php if (!$chk['mp3info']): print "<b>mp3info</b>$output037" ?><?php endif; ?></td>													
</tr>		


<?php
if ($cdinfo == "yes")
	{
	print "<tr><td valign=\"top\">cdinfo</td><td valign=\"top\">";
	echo (($chk['cdinfo'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" >");
	print "</td><td valign=\"top\">";
	if (!$chk['cdinfo'])
		{
		print "<b>cdinfo</b>";
		print "$output037";
		}
	print "</td></tr>";
	}
?>

<?php
if ($cdinfo == "yes")
	{
	print "<tr><td valign=\"top\">cd-discid</td><td valign=\"top\">";
	echo (($chk['cd-discid'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" >");
	print "</td><td valign=\"top\">";
	if (!$chk['cd-discid'])
		{
		print "<b>cd-discid</b>";
		print "$output037";
		}
	print "</td></tr>";
	}
?>

<?php
if ($oggenc == "no" && $prefc == "ogg")
	{
	print "<tr><td valign=\"top\">prefered audio format</td><td valign=\"top\">";
	echo (($chk['prefc'])?"<img src=\"img/icon_activate.gif\" alt=\"\">":"<img src=\"img/icon_cancel.gif\" >");
	print "</td><td valign=\"top\">";
	if (!$chk['prefc'])
		{
		print "$output045";
		}
	print "</td></tr>";
	}

?>


</table>
</td>
</tr>
</table>
</body>
</html>
<?php
		exit;
		
	}
else
	{

$playtp = set_get_cookie($setplaytp, "playtp", "dl", $HTTP_COOKIE_VARS);

print_header ("search", "", "$cgi_dir", "$host", "$requ");

#######################################################################################
### Functions

function show_searchform($artist, $title, $genre, $lang, $yearfrom, $yearto, $rating,
                         $bpmfrom, $bpmto, $source, $created, $modified){
?>
<table border="0">
<tr>
<td class="selformtit"><b>Artist</b> </td>
<td class="selform"> <input type="text" name="artist" value="<?php echo $artist ?>" size="20" maxlength="200">
</td></tr>

<tr>
<td class="selformtit"><b>Title</b></td>
<td class="selform"> <input type="text" name="title"  value="<?php echo $title  ?>" size="20" maxlength="200">
</td></tr>

<tr>
<td class="selformtit"><b>Genre</b></td>
<td class="selform"> 
<select name="genre"><?php print_genre_options($genre); ?></select>
</td></tr>

<tr>
<td class="selformtit"><b>Rating</b></td>
<td class="selform"> 
<select name="rating"><?php print_rating_options($rating); ?></select>
</td></tr>

<tr><td colspan="2" class="selform">
<!--input type="reset" value="Clear">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-->
<input type="submit" value="&nbsp;&nbsp;Search&nbsp;&nbsp;"></td></tr>
</table>
<?php
} # END OF show_selform

#######################################################################################

?>

<p>
<form action="index.php" method="get">

<?php 

show_searchform($artist, $title, $genre, $lang, $yearfrom, $yearto, $rating,
			    $bpmfrom, $bpmto, $source, $created, $modified);
			
#print "Cookie: playtp".$playtp.", showartist ".$showartist." <br>";

if(isset($artist)){
  # open data source
  $dbh = mysql_connect();	

  ### VERY preliminary query
  if (strlen($rating)==0){$rating=0;}
  $recset = mysql_db_query ("GiantDisc", "SELECT * FROM tracks WHERE artist LIKE '%$artist%' AND title LIKE '%".$title."%' AND (genre1 LIKE '".$genre."%' OR genre2 LIKE '".$genre."%') AND rating>=".$rating." ");
print "$title";

  
  if (mysql_affected_rows()>0){print "<hr noshade>";}else{print "<p>&nbsp;</p>";}
  print("<p><small><b>".mysql_affected_rows()." machting tracks</b></small></p>");
  print("<table border=\"0\" cellspacing=\"0\">\n");
  $evenln = 1;
  while($row = mysql_fetch_array($recset)) {
    if ($evenln){
      print "<tr class=\"lneven\">";
	}
	else{
      print "<tr class=\"lnodd\">";
	}
    show_trackrow($row,
	          $showartist, $showtitle, $showgenre, $showlang, $showyear, $showrating,
			  $showbpm, $showsource, $showcreated, $showmodified, $showlength,
			  $showedit, $showdownload, $playtp, $showtoplaylist);
    $evenln = 1-$evenln; #toggle $evenln
	
	print "</tr>\n";
  }
  print("</table>\n");
/*
*/
  mysql_free_result($recset);
}

?>

<hr noshade>
<p>

<?php
#show_showform($showartist, $showtitle, $showgenre, $showlang, $showyear, $showrating,
#			  $showbpm, $showsource, $showcreated, $showmodified, $showlength,
#			  $showedit, $showdownload, $showtoplaylist);
?>

</form>

<?php 
print_footer ("search");


	}
	
?>
		